
#ifndef _CODE_CC
#define _CODE_CC

#define INTTYPE 1
#define ARRAYTYPE 2
#define FUNCINTTYPE 3
#define FUNCVOIDTYPE 4

int topmem = 0 ;
int maintopmem = 0 ;
int gosibling = 1 ;

SSymbolTable symboltable ;

void genCode(Node *node)
{
	STEntry *entry ;
	Node *node2 ;
	int loc ;
	int loc2 ;
	int curloc ;

	if(node == NULL)
		return ;
	switch(node->getType())
	{
		case 4 :
#ifdef _DEBUG_
			printf("* 4 vardeclaration -> typespecifier ID ; | typespecifier ID [ NUM ] ;\n") ;
#endif
			if(node->getNumChild()==2)
			{
				symboltable.insert(node->getChild(1)->getString(), INTTYPE, topmem--) ;
				if(symboltable.lookup(node->getChild(1)->getString())->getGlobal())
					maintopmem = topmem ;
				emitCode(LDA, 6, -1, 6) ;
			}
			else
			{
				int size = node->getChild(2)->getValue() ;
				topmem -= (size + 1) ;
				symboltable.insert(node->getChild(1)->getString(), ARRAYTYPE, topmem + 1) ;
				if(symboltable.lookup(node->getChild(1)->getString())->getGlobal())
					maintopmem = topmem ;
				emitCode(LDA, 6, -(size + 1), 6) ;
				emitCode(LDA, 6, 2, 6) ;
				emitCode(ST, 6, -1, 6) ;
				emitCode(LDA, 6, -2, 6) ;
			}
			break ;
		case 6 :
#ifdef _DEBUG_
			printf("* 6 funcdeclaration -> typespecifier ID ( params ) compoundstmt\n") ;
#endif
			if(node->getChild(0)->getToken() == INT)
				symboltable.insert(node->getChild(1)->getString(), FUNCINTTYPE, currpos + 1) ;
			else
				symboltable.insert(node->getChild(1)->getString(), FUNCVOIDTYPE, currpos + 1) ;
			loc = emitSkip(1) ;
#ifdef _DEBUG_
			printf("* increase scope ( %d -> %d )\n", symboltable.getScope(), symboltable.getScope() + 1) ;
#endif
			symboltable++ ;

			if(strcmp(node->getChild(1)->getString(),"main")==0)
			{
				topmem = maintopmem ;
				genCode(node->getChild(3)) ;
				emitBackup(loc) ;
				emitCode(LDA, 7, 0, 7) ;
				emitRestore() ;
			}
			else if(node->getChild(2)->getToken() == VOID)
			{
				topmem = -2 ;
				genCode(node->getChild(3)) ;
				curloc = emitSkip(0) ;
				emitBackup(loc) ;
				emitCode(LDA, 7, curloc + 3, 5) ;
				emitRestore() ;
			}
			else
			{
				int num = node->getChild(2)->getNumSibling() ;
				node2 = node->getChild(2) ;
				gosibling = 0 ;
				for(int i = 0; i < num; i++)
				{
					if(node2->getChild(2) == NULL)
						symboltable.insert(node2->getChild(1)->getString(), INTTYPE, num - i ) ;
					else
						symboltable.insert(node2->getChild(1)->getString(), ARRAYTYPE, num - i ) ;
					node2 = node2->getSibling() ;
				}
				gosibling = 1 ;
				topmem = -2 ;
				genCode(node->getChild(3)) ;
				curloc = emitSkip(0) ;
				emitBackup(loc) ;
				emitCode(LDA, 7, curloc + 4, 5) ;
				emitRestore() ;
			}
			break ;
		case 9 :
#ifdef _DEBUG_
			printf("* 9 param -> typespecifier ID | typespecifier ID [ ]\n") ;
#endif
			break ;
		case 10 :
#ifdef _DEBUG_
			printf("* 10 compoundstat -> { localdeclarations statementlist }\n") ;
#endif
			genCode(node->getChild(0)) ;
			genCode(node->getChild(1)) ;
			break ;
		case 15 :
#ifdef _DEBUG_
			printf("* 15 selectionstmt -> if ( expression ) statement | if ( expression ) statement else statement\n") ;
			printf("* increase scope ( %d -> %d )\n", symboltable.getScope(), symboltable.getScope() + 1) ;
#endif
			symboltable++ ;
			if(node->getNumChild() == 3)
			{
				genCode(node->getChild(0)) ;
				loc = emitSkip(1) ;
				genCode(node->getChild(1)) ;
				loc2 = emitSkip(1) ;
				curloc = emitSkip(0) ;
				emitBackup(loc) ;
				emitCode(JEQ, 0, curloc, 5) ;
				emitRestore() ;
				genCode(node->getChild(2)) ;
				curloc = emitSkip(0) ;
				emitBackup(loc2) ;
				emitCode(LDA, 7, curloc, 5) ;
				emitRestore() ;
			}
			else
			{
				genCode(node->getChild(0)) ;
				loc = emitSkip(1) ;
				genCode(node->getChild(1)) ;
				curloc = emitSkip(0) ;
				emitBackup(loc) ;
				emitCode(JEQ, 0, curloc, 5) ;
				emitRestore() ;
			}
			break ;
		case 16 :
#ifdef _DEBUG_
			printf("* 16 iterationstmt -> while ( expression ) statement\n") ;
			printf("* increase scope ( %d -> %d )\n", symboltable.getScope(), symboltable.getScope() + 1) ;
#endif
			symboltable++ ;
			loc = emitSkip(0) ;
			genCode(node->getChild(0)) ;
			loc2 = emitSkip(1) ;
			genCode(node->getChild(1)) ;
			emitCode(LDA, 7, loc, 5) ;
			curloc = emitSkip(0) ;
			emitBackup(loc2) ;
			emitCode(JEQ, 0, curloc, 5) ;
			emitRestore() ;
			break ;
		case 17 :
#ifdef _DEBUG_
			printf("* 17 returnstmt -> return ; | return expression ;\n") ;
#endif
			if(node->getChild(0) == NULL)
			{
				emitCode(LDA, 6, 0, 4) ;
				emitCode(LD, 4, 0, 6) ;
				emitCode(LD, 7, -1, 6) ;
			}
			else
				genCode(node->getChild(0)) ;
			break ;
		case 18 :
#ifdef _DEBUG_
			printf("* 18 expression -> var = expression | simpleexpression\n") ;
#endif
			if(node->getNumChild() == 2 && node->getChild(0)->getNumChild() == 0 && node->getToken() == ASSOP )
			{
				genCode(node->getChild(1)) ;
				entry = symboltable.lookup(node->getChild(0)->getString()) ;
				if(entry->getGlobal())
				{
					emitCode(LD, 3, 0, 5) ;
					emitCode(ST, 0, entry->getOffset(), 3) ;
				}
				else
					emitCode(ST, 0, entry->getOffset(), 4) ;
			}
			else if(node->getNumChild() == 2 && node->getChild(0)->getNumChild() == 2 && node->getToken() == ASSOP)
			{
				genCode(node->getChild(0)->getChild(1)) ;
				emitCode(ST, 0, 0, 6) ;
				emitCode(LDA, 6, -1, 6) ;
				genCode(node->getChild(1)) ;
				emitCode(LDA, 6, 1, 6) ;
				emitCode(LD, 1, 0, 6) ;
				entry = symboltable.lookup(node->getChild(0)->getChild(0)->getString()) ;
				if(entry->getGlobal())
				{
					emitCode(LD, 3, 0, 5) ;
					emitCode(LDA, 3, entry->getOffset(), 3) ;
					emitCode(LD, 3, 0, 3) ;
					emitCode(ADD, 3, 1, 3) ;
					emitCode(ST, 0, 0, 3) ;
				}
				else
				{
					emitCode(LDA, 3, entry->getOffset(), 4) ;
					emitCode(LD, 3, 0, 3) ;
					emitCode(ADD, 3, 1, 3) ;
					emitCode(ST, 0, 0, 3) ;
				}
			}
			else
				genCode(node->getChild(0)) ;

			break ;
		case 20:
#ifdef _DEBUG_
			printf("* 20 simpleexpression -> additiveexpression relop additiveexpression | additiveexpression\n") ;
#endif
			if(node->getNumChild() == 2 && ( node->getToken() == EQ || node->getToken() == NE || node->getToken() == LT || node->getToken() == LE || node->getToken() == GT || node->getToken() == GE ) )
			{
				genCode(node->getChild(0)) ;
				emitCode(ST, 0, 0, 6) ;
				emitCode(LDA, 6, -1, 6) ;
				genCode(node->getChild(1)) ;
				emitCode(LDA, 6, 1, 6) ;
				emitCode(LD, 1, 0, 6) ;
				switch(node->getToken())
				{
					case EQ:
						emitCode(SUB, 0, 1, 0) ;
						emitCode(JEQ, 0, 2, 7) ;
						emitCode(LDC, 0, 0, 0) ;
						emitCode(LDA, 7, 1, 7) ;
						emitCode(LDC, 0, 1, 0) ;
						break;
					case NE:
						emitCode(SUB, 0, 1, 0) ;
						emitCode(JNE, 0, 2, 7) ;
						emitCode(LDC, 0, 0, 0) ;
						emitCode(LDA, 7, 1, 7) ;
						emitCode(LDC, 0, 1, 0) ;
						break;
					case LT:
						emitCode(SUB, 0, 1, 0) ;
						emitCode(JLT, 0, 2, 7) ;
						emitCode(LDC, 0, 0, 0) ;
						emitCode(LDA, 7, 1, 7) ;
						emitCode(LDC, 0, 1, 0) ;
						break;
					case LE:
						emitCode(SUB, 0, 1, 0) ;
						emitCode(JLE, 0, 2, 7) ;
						emitCode(LDC, 0, 0, 0) ;
						emitCode(LDA, 7, 1, 7) ;
						emitCode(LDC, 0, 1, 0) ;
						break;
					case GT:
						emitCode(SUB, 0, 1, 0) ;
						emitCode(JGT, 0, 2, 7) ;
						emitCode(LDC, 0, 0, 0) ;
						emitCode(LDA, 7, 1, 7) ;
						emitCode(LDC, 0, 1, 0) ;
						break;
					case GE:
						emitCode(SUB, 0, 1, 0) ;
						emitCode(JGE, 0, 2, 7) ;
						emitCode(LDC, 0, 0, 0) ;
						emitCode(LDA, 7, 1, 7) ;
						emitCode(LDC, 0, 1, 0) ;
						break;
					default:
						printf("Unknown relop\n") ;
						break;
				}
			}
			else
				genCode(node->getChild(0)) ;
			break ;
		case 22 :
#ifdef _DEBUG_
			printf("* 22 additiveexpression -> additiveexpression addop term | term\n") ;
#endif
			if(node->getNumChild() == 2 && ( node->getToken() == PLUS || node->getToken() == MINUS ))
			{
				genCode(node->getChild(0)) ;
				emitCode(ST, 0, 0, 6) ;
				emitCode(LDA, 6, -1, 6) ;
				genCode(node->getChild(1)) ;
				emitCode(LDA, 6, 1, 6) ;
				emitCode(LD, 1, 0, 6) ;
				switch(node->getToken())
				{
					case PLUS :
						emitCode(ADD, 0, 1, 0) ;
						break ;
					case MINUS :
						emitCode(SUB, 0, 1, 0) ;
						break ;
					default :
						printf("Unknown addop\n") ;
						break ;
				}
			}
			else
				genCode(node->getChild(0)) ;
			break ;
		case 24 :
#ifdef _DEBUG_
			printf("* 24 term -> term mulop factor | factor\n") ;
#endif
			if(node->getNumChild() == 2 && ( node->getToken() == MULT || node->getToken() == DIVI ))
			{
				genCode(node->getChild(0)) ;
				emitCode(ST, 0, 0, 6) ;
				emitCode(LDA, 6, -1, 6) ;
				genCode(node->getChild(1)) ;
				emitCode(LDA, 6, 1, 6) ;
				emitCode(LD, 1, 0, 6) ;
				switch(node->getToken())
				{
					case MULT :
						emitCode(MUL, 0, 1, 0) ;
						break ;
					case DIVI :
						emitCode(DIV, 0, 1, 0) ;
						break ;
					default :
						printf("Unknown mulop\n") ;
						break ;
				}
			}
			else
				genCode(node->getChild(0)) ;
			break ;
		case 27 :
#ifdef _DEBUG_
			printf("* 27 call -> ID ( args )\n") ;
#endif
			if(strcmp(node->getChild(0)->getString(), "output") == 0)
			{
				genCode(node->getChild(1)) ;
				emitCode(OUT, 0, 0, 0) ;
			}
			else if(strcmp(node->getChild(0)->getString(), "input") == 0)
				emitCode(IN, 0, 0, 0) ;
			else if(node->getChild(1) == NULL)
			{
				emitCode(ST, 4, 0, 6) ;
				emitCode(LDA, 4, 0, 6) ;
				emitCode(LDA, 6, -1, 6) ;
				emitCode(LDA, 3, 3, 7) ;
				emitCode(ST, 3, 0, 6) ;
				emitCode(LDA, 6, -1, 6) ;
				emitCode(LDA, 7, symboltable.lookup(node->getChild(0)->getString())->getOffset(), 5) ;
			}
			else
			{
				int num = node->getChild(1)->getNumSibling() ;
				node2 = node->getChild(1) ;
				gosibling = 0 ;
				for(int i = 0; i < num; i++)
				{
					genCode(node2) ;
					emitCode(ST, 0, 0, 6) ;
					emitCode(LDA, 6, -1, 6) ;
					node2 = node2->getSibling() ;
				}
				gosibling = 1 ;
				emitCode(ST, 4, 0, 6) ;
				emitCode(LDA, 4, 0, 6) ;
				emitCode(LDA, 6, -1, 6) ;
				emitCode(LDA, 3, 3, 7) ;
				emitCode(ST, 3, 0, 6) ;
				emitCode(LDA, 6, -1, 6) ;
				emitCode(LDA, 7, symboltable.lookup(node->getChild(0)->getString())->getOffset(), 5) ;
			}
			break ;
		case 30 :
#ifdef _DEBUG_
			printf("* 30 terminal or etc\n") ;
#endif
			if(node->getToken() == NUMBER)
			{
				emitCode(LDC, 0, node->getValue(), 0) ;
			}
			else if(node->getToken() == ID)
			{
				entry = symboltable.lookup(node->getString()) ;
				emitCode(LD, 0, entry->getOffset(), 4) ;
			}
			break ;
		case 31:
#ifdef _DEBUG_
			printf("* 31 var -> ident [ expression ]\n") ;
#endif
			genCode(node->getChild(1)) ;
			emitCode(ST, 0, 0, 6) ;
			emitCode(LDA, 6, -1, 6) ;
			genCode(node->getChild(0)) ;
			emitCode(LDA, 6, 1, 6) ;
			emitCode(LD, 1, 0, 6) ;
			entry = symboltable.lookup(node->getChild(0)->getString()) ;
			if(entry->getGlobal())
			{
				emitCode(LD, 3, 0, 5) ;
				emitCode(LDA, 3, entry->getOffset(), 3) ;
				emitCode(LD, 3, 0, 3) ;
				emitCode(ADD, 3, 1, 3) ;
				emitCode(LD, 0, 0, 3) ;
			}
			else
			{
				emitCode(LDA, 3, entry->getOffset(), 4) ;
				emitCode(LD, 3, 0, 3) ;
				emitCode(ADD, 3, 1, 3) ;
				emitCode(LD, 0, 0, 3) ;
			}
			break ;
		default:
			printf("* Unknown type\n") ;
			break ;
	}

	switch(node->getType())
	{
		case 6 :
			if(strcmp(node->getChild(1)->getString(), "main") !=0 )
			{
				if(node->getChild(2)->getToken() == VOID)
				{
					emitCode(LDA, 6, 0, 4) ;
					emitCode(LD, 4, 0, 6) ;
					emitCode(LD, 7, -1, 6) ;
				}
				else
				{
					emitCode(LDA, 6, 0, 4) ;
					emitCode(LD, 4, 0, 6) ;
					emitCode(LDA, 6, node->getChild(2)->getNumSibling(), 6) ;
					emitCode(LD, 7, -node->getChild(2)->getNumSibling() - 1, 6) ;
				}
			}
		case 15 :
		case 16 :
#ifdef _DEBUG_
			printf("* decrease scope ( %d -> %d )\n" , symboltable.getScope(), symboltable.getScope() - 1) ;
#endif
			symboltable-- ;
			break ;
		default :
			break ;
	}

	if(gosibling)
		genCode(node->getSibling()) ;
}

#endif
