
#ifndef _EMIT_CC
#define _EMIT_CC

#include<stdio.h>

#define HALT 0
#define IN 1
#define OUT 2
#define ADD 3
#define SUB 4
#define MUL 5
#define DIV 6
#define LD 7
#define LDA 8
#define LDC 9
#define ST 10
#define JLT 11
#define JLE 12
#define JGE 13
#define JGT 14
#define JEQ 15
#define JNE 16

int currpos = 0 ;
int highpos = 0 ;

int emitSkip(int howmany)
{
	int i = currpos ;
	currpos += howmany ;
	if(highpos < currpos)
		highpos = currpos ;
	return i ;
}

void emitBackup(int pos)
{
	currpos = pos ;
}

void emitRestore()
{
	currpos = highpos ;
}

void emitCode(int op, int r, int s, int t)
{
	switch(op)
	{
		case HALT :
			printf("%d: %s %d,%d,%d\n", currpos++, "HALT", r, s, t) ;
			break ;
		case IN :
			printf("%d: %s %d,%d,%d\n", currpos++, "IN", r, s, t) ;
			break ;
		case OUT :
			printf("%d: %s %d,%d,%d\n", currpos++, "OUT", r, s, t) ;
			break ;
		case ADD :
			printf("%d: %s %d,%d,%d\n", currpos++, "ADD", r, s, t) ;
			break ;
		case SUB :
			printf("%d: %s %d,%d,%d\n", currpos++, "SUB", r, s, t) ;
			break ;
		case MUL :
			printf("%d: %s %d,%d,%d\n", currpos++, "MUL", r, s, t) ;
			break ;
		case DIV :
			printf("%d: %s %d,%d,%d\n", currpos++, "DIV", r, s, t) ;
			break ;
		case LD :
			printf("%d: %s %d,%d(%d)\n", currpos++, "LD", r, s, t) ;
			break ;
		case LDA :
			printf("%d: %s %d,%d(%d)\n", currpos++, "LDA", r, s, t) ;
			break ;
		case LDC :
			printf("%d: %s %d,%d(%d)\n", currpos++, "LDC", r, s, t) ;
			break ;
		case ST :
			printf("%d: %s %d,%d(%d)\n", currpos++, "ST", r, s, t) ;
			break ;
		case JLT :
			printf("%d: %s %d,%d(%d)\n", currpos++, "JLT", r, s, t) ;
			break ;
		case JLE :
			printf("%d: %s %d,%d(%d)\n", currpos++, "JLE", r, s, t) ;
			break ;
		case JGE :
			printf("%d: %s %d,%d(%d)\n", currpos++, "JGE", r, s, t) ;
			break ;
		case JGT :
			printf("%d: %s %d,%d(%d)\n", currpos++, "JGT", r, s, t) ;
			break ;
		case JEQ :
			printf("%d: %s %d,%d(%d)\n", currpos++, "JEQ", r, s, t) ;
			break ;
		case JNE :
			printf("%d: %s %d,%d(%d)\n", currpos++, "JNE", r, s, t) ;
			break ;
		default :
			printf("Unknown opcode\n") ;
			return ;
			break ;
	}
	if(highpos < currpos)
		highpos = currpos ;
}

#endif
