#include <string.h>
#include "STEntry.h"

/**
* STEntry is the entry of symbol table. This is element class of symbol table.
*
* @author       Taeho Oh
* @version      0.0.1
* @since        1999/03/31
*/
class STEntry
{
private:
	/**
	* The lexeme.
	*/
	char lexeme[256] ;

	/**
	* The token of lexeme.
	*/
	int token ;

	/**
	* The offset of the lexeme.
	*/
	int offset ;

	/**
	* 1 if the lexeme is global.
	*/
	int global ;

	/**
	* The next symbol table entry of this STEntry.
	*/
	STEntry *next ;

	void setLexeme(const char * const lexeme)
	{
//		if(this->lexeme != NULL)
//			delete this->lexeme ;
//		this->lexeme = new char[strlen(lexeme)] ;	
		strcpy(this->lexeme, lexeme) ;
	}

	void setToken(const int token)
	{
		this->token = token ;
	}

	void setOffset(const int offset)
	{
		this->offset = offset ;
	}

	void setGlobal(const int global)
	{
		this->global = global ;
	}
public:
	/**
	* Initialize symbol table entry. lexeme, token and next.
	*/
	STEntry(const char * const lexeme, const int token, const int offset, const int global)
	{
		setLexeme(lexeme) ;
		setToken(token) ;
		setOffset(offset) ;
		setGlobal(global) ;
		setNext(NULL) ;
	}

	char *getLexeme()
	{
		return lexeme ;
	}

	int getToken() const
	{
		return token ;
	}

	int getOffset() const
	{
		return offset ;
	}

	int getGlobal() const
	{
		return global ;
	}

	STEntry *getNext() const
	{
		return next ;
	}

	void setNext(STEntry * const next)
	{
		this->next = next ;
	}
} ;
