%{
#include  "y.tab.h"
%}

comment		"/*"([^\*\/]|\*[^/]|[^\*]\/)*"*/"
delim		[ \t\n]
ws		{delim}+
letter		[A-Za-z]
digit		[0-9]
id		{letter}({letter}|{digit})*
number		{digit}+

%%

{comment}	{}
{ws}		{}
"else"		{ return (ELSE) ; }
"if"		{ return (IF) ; }
"int"		{ return (INT) ; }
"return"	{ return (RETURN) ; }
"void"		{ return (VOID) ; }
"while"		{ return (WHILE) ; }

"("		{ return (SPARENL) ; }
")"		{ return (SPARENR) ; }
"{"		{ return (MPARENL) ; }
"}"		{ return (MPARENR) ; }
"["		{ return (BPARENL) ; }
"]"		{ return (BPARENR) ; }

{id}		{ return (ID) ; }
{number}	{ return (NUMBER) ; }

"<"		{ return (LT) ; }
"<="		{ return (LE) ; }
">"		{ return (GT) ; }
">="		{ return (GE) ; }
"=="		{ return (EQ) ; }
"!="		{ return (NE) ; }

"+"		{ return (PLUS) ; }
"-"		{ return (MINUS) ; }
"*"		{ return (MULT) ; }
"/"		{ return (DIVI) ; }
"="		{ return (ASSOP) ; }

";"		{ return (SEMICLN) ; }
","		{ return (COMMA) ; }

%%

